Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj	(revision 14128)
@@ -108,30 +108,27 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Core.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.MainForm-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Optimization.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
+    <Reference Include="HeuristicLab.Collections-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Collections-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core.Views-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core.Views-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data.Views-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Data.Views-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.MainForm-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.MainForm-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -177,4 +174,22 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="PackingPlan2DView.resx">
+      <DependentUpon>PackingPlan2DView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="PackingPlan3DView.resx">
+      <DependentUpon>PackingPlan3DView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
+  <ItemGroup>
+    <Page Include="Container3DView.xaml">
+      <Generator>MSBuild:Compile</Generator>
+      <SubType>Designer</SubType>
+    </Page>
+    <Page Include="Container2DView.xaml">
+      <Generator>MSBuild:Compile</Generator>
+      <SubType>Designer</SubType>
+    </Page>
+  </ItemGroup>
+  <ItemGroup>
     <ProjectReference Include="..\..\HeuristicLab.Problems.BinPacking.2D\3.3\HeuristicLab.Problems.BinPacking2D-3.3.csproj">
       <Project>{56dd7f51-3164-4c26-a97a-add6fe4b4e86}</Project>
@@ -186,26 +201,7 @@
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.BinPacking\3.3\HeuristicLab.Problems.BinPacking-3.3.csproj">
-      <Project>{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}</Project>
+      <Project>{f8a55094-3cd5-4034-b0ca-5bd7ffb016d4}</Project>
       <Name>HeuristicLab.Problems.BinPacking-3.3</Name>
-      <Private>False</Private>
     </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="PackingPlan2DView.resx">
-      <DependentUpon>PackingPlan2DView.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="PackingPlan3DView.resx">
-      <DependentUpon>PackingPlan3DView.cs</DependentUpon>
-    </EmbeddedResource>
-  </ItemGroup>
-  <ItemGroup>
-    <Page Include="Container3DView.xaml">
-      <Generator>MSBuild:Compile</Generator>
-      <SubType>Designer</SubType>
-    </Page>
-    <Page Include="Container2DView.xaml">
-      <Generator>MSBuild:Compile</Generator>
-      <SubType>Designer</SubType>
-    </Page>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Analyzers/BestBinPackingSolutionAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Analyzers/BestBinPackingSolutionAnalyzer.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Analyzers/BestBinPackingSolutionAnalyzer.cs	(revision 14128)
@@ -93,5 +93,5 @@
       }
       string binUtilKey = "Overall Bin Utilization";
-      DoubleValue binUtil = BinUtilizationEvaluator<D, B, I>.CalculateBinUtilization(bestSolution);
+      var binUtil = new DoubleValue(BinUtilizationEvaluator<D, B, I>.CalculateBinUtilization(bestSolution));
       if (!results.ContainsKey(binUtilKey))
         results.Add(new Result(binUtilKey, binUtil));
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/BinPacking.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/BinPacking.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/BinPacking.cs	(revision 14128)
@@ -40,8 +40,8 @@
 
     [Storable]
-    public ObservableDictionary<int, I> ItemMeasures { get; private set; } // TODO: renamed to item
+    public ObservableDictionary<int, I> ItemMeasures { get; private set; } // TODO: rename to items
 
     [Storable]
-    public B BinMeasures { get; private set; }
+    public B BinMeasures { get; private set; } 
 
     [Storable]
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs	(revision 14128)
@@ -28,9 +28,7 @@
 using HeuristicLab.Data;
 using HeuristicLab.Collections;
-using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
-using HeuristicLab.Encodings.PackingEncoding.GroupingVector;
-using HeuristicLab.Encodings.PackingEncoding.PackingSequence;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Problems.BinPacking;
+using HeuristicLab.Encodings.PermutationEncoding;
 
 namespace HeuristicLab.Encodings.PackingEncoding {
@@ -98,4 +96,5 @@
     }
 
+    /*
     public void Pack(MultiComponentVectorEncoding solution, ItemList<I> itemMeasures) {
       var sequenceMatrix = solution.GenerateSequenceMatrix();
@@ -197,6 +196,8 @@
       solution.GroupingVector = new IntegerVector(newSolution);
     }
-    public void Pack(PackingSequenceEncoding solution, ItemList<I> itemMeasures) {
-      List<int> remainingIDs = new List<int>(solution.PackingSequence);
+     * 
+     
+    public void Pack(Permutation solution, ItemList<I> itemMeasures) {
+      List<int> remainingIDs = new List<int>(solution);
       while (remainingIDs.Count > 0) {
         var bp = NewBinPacking();
@@ -210,5 +211,5 @@
     }
 
-
+    */
     #region Events
     public event EventHandler QualityChanged;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Encoding.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Encoding.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Encoding.cs	(revision 14128)
@@ -6,4 +6,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -13,8 +14,9 @@
 namespace HeuristicLab.Encodings.PackingEncoding.PackingSequence {
   [StorableClass]
-  internal class Encoding : HeuristicLab.Optimization.Encoding<PackingSolutionCreator> {
+  public class Encoding : HeuristicLab.Optimization.Encoding<IPackingSolutionCreator> {
     [StorableConstructor]
     private Encoding(bool deserializing) : base(deserializing) { }
-    public Encoding() : base("PackingSequence") {
+    public Encoding()
+      : base("PackingSequence") {
       SolutionCreator = new PackingSequenceRandomCreator();
       RegisterParameterEvents();
@@ -64,11 +66,11 @@
 
   public static class IndividualExtensionMethods {
-    public static PackingSequence PackingSequence(this Individual individual) {
+    public static Permutation PackingSequence(this Individual individual) {
       var encoding = individual.GetEncoding<Encoding>();
       return individual.PackingSequence(encoding.Name);
     }
 
-    public static PackingSequence PackingSequence(this Individual individual, string name) {
-      return (PackingSequence)individual[name];
+    public static Permutation PackingSequence(this Individual individual, string name) {
+      return (Permutation)individual[name];
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/IPackingSequenceCreator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/IPackingSequenceCreator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/IPackingSequenceCreator.cs	(revision 14128)
@@ -23,4 +23,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Problems.BinPacking;
@@ -28,7 +29,6 @@
 namespace HeuristicLab.Encodings.PackingEncoding.PackingSequence {
   interface IPackingSequenceCreator : ISolutionCreator, IPackingSequenceOperator {
-    IValueLookupParameter<IntValue> PackingItemsParameter { get; }
-    ILookupParameter<PackingSequence> SolutionParameter { get; }
-
+    ILookupParameter<IntValue> NumberOfPackingItemsParameter { get; }
+    ILookupParameter<Permutation> SolutionParameter { get; }
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveHardTabuCriterion.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveHardTabuCriterion.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveHardTabuCriterion.cs	(revision 14128)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
@@ -37,9 +38,9 @@
       get { return false; }
     }
-    public ILookupParameter<IPackingMove> PackingMoveParameter {
-      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
+    public ILookupParameter<IPackingMove<Permutation>> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove<Permutation>>)Parameters["PackingMove"]; }
     }
-    public ILookupParameter<PackingSequenceEncoding> PackingSequenceParameter {
-      get { return (ILookupParameter<PackingSequenceEncoding>)Parameters["PackingSequence"]; }
+    public ILookupParameter<Permutation> PackingSequenceParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PackingSequence"]; }
     }
     public ILookupParameter<ItemList<IItem>> TabuListParameter {
@@ -64,6 +65,6 @@
     public SequenceMoveHardTabuCriterion()
       : base() {
-      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
-      Parameters.Add(new LookupParameter<PackingSequenceEncoding>("PackingSequence", "The solution to evaluate."));
+      Parameters.Add(new LookupParameter<IPackingMove<Permutation>>("PackingMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<Permutation>("PackingSequence", "The solution candidate to evaluate."));
       Parameters.Add(new LookupParameter<BoolValue>("MoveTabu", "The variable to store if a move was tabu."));
       Parameters.Add(new LookupParameter<ItemList<IItem>>("TabuList", "The tabu list."));
@@ -80,10 +81,8 @@
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       SequenceMove move = PackingMoveParameter.ActualValue as SequenceMove;
-      PackingSequenceEncoding PackingSequence = PackingSequenceParameter.ActualValue;
-      int length = PackingSequence.PackingSequence.Length;
       double moveQuality = MoveQualityParameter.ActualValue.Value;
       bool maximization = MaximizationParameter.ActualValue.Value;
       bool useAspiration = UseAspirationCriterionParameter.Value.Value;
-      bool isTabu = IsMoveTabu(tabuList, move, PackingSequence, moveQuality, maximization, useAspiration);
+      bool isTabu = IsMoveTabu(tabuList, move, moveQuality, maximization, useAspiration);
 
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
@@ -91,7 +90,7 @@
     }
 
-    private bool IsMoveTabu(ItemList<IItem> tabuList, SequenceMove move, PackingSequenceEncoding PackingSequence, double moveQuality, bool maximization, bool useAspiration) {
+    private bool IsMoveTabu(ItemList<IItem> tabuList, SequenceMove move, double moveQuality, bool maximization, bool useAspiration) {
       bool isTabu = false;
-      var attributes = tabuList.FindAll(ta => ta.GetType().Equals(move.GetMoveAttributeType()));
+      var attributes = tabuList.FindAll(ta => ta.GetType() == move.GetMoveAttributeType());
 
       foreach (IItem attr in attributes) {
@@ -102,5 +101,5 @@
               || !maximization && moveQuality >= gvAttr.MoveQuality)) {
 
-          isTabu = move.BelongsToAttribute(gvAttr, true);
+          isTabu = move.BelongsToAttribute(gvAttr, true); // only difference to soft tabu criterion
         }
         if (isTabu) break;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveMaker.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveMaker.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveMaker.cs	(revision 14128)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
@@ -43,9 +44,9 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["MoveQuality"]; }
     }
-    public ILookupParameter<IPackingMove> PackingMoveParameter {
-      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
+    public ILookupParameter<IPackingMove<Permutation>> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove<Permutation>>)Parameters["PackingMove"]; }
     }
-    public ILookupParameter<PackingSequenceEncoding> PackingSequenceParameter {
-      get { return (ILookupParameter<PackingSequenceEncoding>)Parameters["PackingSequence"]; }
+    public ILookupParameter<Permutation> PackingSequenceParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PackingSequence"]; }
     }
     public ILookupParameter<IPackingPlan> PackingPlanParameter {
@@ -62,7 +63,7 @@
       : base() {
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the solution."));
-      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<IPackingMove<Permutation>>("PackingMove", "The move to evaluate."));
       Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The relative quality of the move."));
-      Parameters.Add(new LookupParameter<PackingSequenceEncoding>("PackingSequence", "The solution as Sequence vector."));
+      Parameters.Add(new LookupParameter<Permutation>("PackingSequence", "The solution as Sequence vector."));
       Parameters.Add(new LookupParameter<IPackingPlan>("PackingPlan", "The currently best performing, decoded bin-packing solution represented as generalized packing-plan."));
       Parameters.Add(new LookupParameter<IPackingPlan>("PackingPlanAfterMove", "The moved and decoded bin-packing solution represented as generalized packing-plan."));
@@ -74,10 +75,7 @@
 
     public override IOperation Apply() {
-      IPackingMove move = PackingMoveParameter.ActualValue;
-      PackingSequenceEncoding PackingSequence = PackingSequenceParameter.ActualValue;
       DoubleValue moveQuality = MoveQualityParameter.ActualValue;
       DoubleValue quality = QualityParameter.ActualValue;
 
-      PackingSequence.PackingSequence = (move.GetSolutionAfterMove() as PackingSequenceEncoding).PackingSequence;
       PackingPlanParameter.ActualValue = PackingPlanAfterMoveParameter.ActualValue;
 
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveSoftTabuCriterion.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveSoftTabuCriterion.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/GroupingMoveSoftTabuCriterion.cs	(revision 14128)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
@@ -38,9 +39,9 @@
       get { return false; }
     }
-    public ILookupParameter<IPackingMove> PackingMoveParameter {
-      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
+    public ILookupParameter<IPackingMove<Permutation>> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove<Permutation>>)Parameters["PackingMove"]; }
     }
-    public ILookupParameter<PackingSequenceEncoding> PackingSequenceParameter {
-      get { return (ILookupParameter<PackingSequenceEncoding>)Parameters["PackingSequence"]; }
+    public ILookupParameter<Permutation> PackingSequenceParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PackingSequence"]; }
     }
     public ILookupParameter<ItemList<IItem>> TabuListParameter {
@@ -65,6 +66,6 @@
     public SequenceMoveSoftTabuCriterion()
       : base() {
-      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
-      Parameters.Add(new LookupParameter<PackingSequenceEncoding>("PackingSequence", "The solution to evaluate."));
+      Parameters.Add(new LookupParameter<IPackingMove<Permutation>>("PackingMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<Permutation>("PackingSequence", "The solution to evaluate."));
       Parameters.Add(new LookupParameter<BoolValue>("MoveTabu", "The variable to store if a move was tabu."));
       Parameters.Add(new LookupParameter<ItemList<IItem>>("TabuList", "The tabu list."));
@@ -81,10 +82,8 @@
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       SequenceMove move = PackingMoveParameter.ActualValue as SequenceMove;
-      PackingSequenceEncoding PackingSequence = PackingSequenceParameter.ActualValue;
-      int length = PackingSequence.PackingSequence.Length;
       double moveQuality = MoveQualityParameter.ActualValue.Value;
-      bool maximization = MaximizationParameter.ActualValue.Value;   
+      bool maximization = MaximizationParameter.ActualValue.Value;
       bool useAspiration = UseAspirationCriterionParameter.Value.Value;
-      bool isTabu = IsMoveTabu(tabuList, move, PackingSequence, moveQuality, maximization, useAspiration);
+      bool isTabu = IsMoveTabu(tabuList, move, moveQuality, maximization, useAspiration);
 
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
@@ -92,7 +91,7 @@
     }
 
-    private bool IsMoveTabu(ItemList<IItem> tabuList, SequenceMove move, PackingSequenceEncoding PackingSequence, double moveQuality, bool maximization, bool useAspiration) {
+    private bool IsMoveTabu(ItemList<IItem> tabuList, SequenceMove move, double moveQuality, bool maximization, bool useAspiration) {
       bool isTabu = false;
-      var attributes = tabuList.FindAll(ta => ta.GetType().Equals(move.GetMoveAttributeType()));
+      var attributes = tabuList.FindAll(ta => ta.GetType() == move.GetMoveAttributeType());
 
       foreach (IItem attr in attributes) {
@@ -103,5 +102,5 @@
               || !maximization && moveQuality >= gvAttr.MoveQuality)) {
 
-          isTabu = move.BelongsToAttribute(gvAttr, false);
+          isTabu = move.BelongsToAttribute(gvAttr, false); // only difference to hard tabu criterion 
         }
         if (isTabu) break;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/ExhaustiveInsertionMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/ExhaustiveInsertionMoveGenerator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/ExhaustiveInsertionMoveGenerator.cs	(revision 14128)
@@ -24,4 +24,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -39,15 +40,15 @@
       return new ExhaustiveInsertionMoveGenerator(this, cloner);
     }
-    public static IEnumerable<InsertionMove> Generate(PackingSequenceEncoding PackingSequence, int nrOfBins) {
-      for (int i = 0; i < PackingSequence.PackingSequence.Length - 1; i++)
-        for (int j = i + 1; j < PackingSequence.PackingSequence.Length; j++) {
+    public static IEnumerable<InsertionMove> Generate(Permutation packingSequence, int nrOfBins) {
+      for (int i = 0; i < packingSequence.Length - 1; i++)
+        for (int j = i + 1; j < packingSequence.Length; j++) {
           if (j != i)
-            yield return new InsertionMove(i, j, PackingSequence);
+            yield return new InsertionMove(i, j, packingSequence);
         }
     }
 
-    public static InsertionMove[] Apply(PackingSequenceEncoding PackingSequence) {
+    public static InsertionMove[] Apply(Permutation packingSequence) {
       int nrOfBins = 0;
-      foreach (int binNr in PackingSequence.PackingSequence) {
+      foreach (int binNr in packingSequence) {
         if (binNr > nrOfBins)
           nrOfBins = binNr;
@@ -55,8 +56,8 @@
       nrOfBins++;
 
-      int totalMoves = (PackingSequence.PackingSequence.Length * (PackingSequence.PackingSequence.Length - 1)) / 2;
+      int totalMoves = (packingSequence.Length * (packingSequence.Length - 1)) / 2;
       InsertionMove[] moves = new InsertionMove[totalMoves];
       int count = 0;
-      foreach (InsertionMove move in Generate(PackingSequence, nrOfBins)) {
+      foreach (InsertionMove move in Generate(packingSequence, nrOfBins)) {
         moves[count++] = move;
       }
@@ -64,6 +65,6 @@
     }
 
-    protected override InsertionMove[] GenerateMoves(PackingSequenceEncoding PackingSequence) {
-      return Apply(PackingSequence);
+    protected override InsertionMove[] GenerateMoves(Permutation packingSequence) {
+      return Apply(packingSequence);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/InsertionMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/InsertionMove.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/InsertionMove.cs	(revision 14128)
@@ -32,5 +32,5 @@
   [Item("Insertion Move", "A move on a Sequence vector that is specified by two group-assignment-indexes.")]
   [StorableClass]
-  public class InsertionMove : SequenceMove, IPackingMove {
+  public class InsertionMove : SequenceMove {
     [Storable]
     public int Index1 { get; protected set; }
@@ -45,6 +45,6 @@
       this.Index2 = original.Index2;
     }
-    public InsertionMove(int index1, int index2, PackingSequenceEncoding PackingSequence)
-      : base(PackingSequence) {
+    public InsertionMove(int index1, int index2, Permutation packingSequence)
+      : base(packingSequence) {
       Index1 = index1;
       Index2 = index2;
@@ -55,9 +55,7 @@
     }
 
-    public override IPackingSolutionEncoding GetSolutionAfterMove() {
-      PackingSequenceEncoding newSolution = new PackingSequenceEncoding();
-
-      Permutation original = PackingSequence.PackingSequence;
-      Permutation resultingPermutation = (Permutation)PackingSequence.PackingSequence.Clone();
+    public override Permutation GetSolutionAfterMove() {
+      Permutation original = PackingSequence;
+      Permutation resultingPermutation = (Permutation)PackingSequence.Clone();
       int cutIndex, insertIndex, number;
 
@@ -68,5 +66,5 @@
       int i = 0;  // index in new permutation
       int j = 0;  // index in old permutation
-      while (i < PackingSequence.PackingSequence.Length) {
+      while (i < PackingSequence.Length) {
         if (j == cutIndex) {
           j++;
@@ -83,6 +81,5 @@
       }
 
-      newSolution.PackingSequence = resultingPermutation;
-      return newSolution;
+      return resultingPermutation;
     }
 
@@ -92,5 +89,5 @@
 
     public override SequenceMoveAttribute GetAttribute(double quality) {
-      return new InsertionMoveAttribute(Index1, Index2, PackingSequence.PackingSequence[Index1], PackingSequence.PackingSequence[Index2], quality);
+      return new InsertionMoveAttribute(Index1, Index2, PackingSequence[Index1], PackingSequence[Index2], quality);
     }
 
@@ -103,5 +100,5 @@
         } else
           if (Index1 == attr.Index1 && Index2 == attr.Index2)
-          return true;
+            return true;
       }
       return false;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/InsertionMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/InsertionMoveGenerator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/InsertionMoveGenerator.cs	(revision 14128)
@@ -23,4 +23,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
@@ -37,9 +38,9 @@
       get { return false; }
     }
-    public ILookupParameter<PackingSequenceEncoding> PackingSequenceParameter {
-      get { return (ILookupParameter<PackingSequenceEncoding>)Parameters["PackingSequence"]; }
+    public ILookupParameter<Permutation> PackingSequenceParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PackingSequence"]; }
     }
-    public ILookupParameter<IPackingMove> PackingMoveParameter {
-      get { return (LookupParameter<IPackingMove>)Parameters["PackingMove"]; }
+    public ILookupParameter<IPackingMove<Permutation>> PackingMoveParameter {
+      get { return (LookupParameter<IPackingMove<Permutation>>)Parameters["PackingMove"]; }
     }
     protected ScopeParameter CurrentScopeParameter {
@@ -52,11 +53,11 @@
     public InsertionMoveGenerator()
       : base() {
-      Parameters.Add(new LookupParameter<PackingSequenceEncoding>("PackingSequence", "The Sequence vector for which moves should be generated."));
-      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The moves that should be generated in subscopes."));
+      Parameters.Add(new LookupParameter<Permutation>("PackingSequence", "The Sequence vector for which moves should be generated."));
+      Parameters.Add(new LookupParameter<IPackingMove<Permutation>>("PackingMove", "The moves that should be generated in subscopes."));
       Parameters.Add(new ScopeParameter("CurrentScope", "The current scope where the moves should be added as subscopes."));
     }
 
     public override IOperation Apply() {
-      PackingSequenceEncoding ps = PackingSequenceParameter.ActualValue;
+      Permutation ps = PackingSequenceParameter.ActualValue;
       InsertionMove[] moves = GenerateMoves(ps);
       Scope[] moveScopes = new Scope[moves.Length];
@@ -69,5 +70,5 @@
     }
 
-    protected abstract InsertionMove[] GenerateMoves(PackingSequenceEncoding PackingSequence);
+    protected abstract InsertionMove[] GenerateMoves(Permutation packingSequence);
   }
 }
